<?php

class Email extends Module 
{

	function Email() {
	}

	function module_init( $moduleNamespace) {
	}

	public function sendPlainMail( $to, $from, $subject, $message) {
		$emailHeaders = "From: $from <$from>\r\n";
		$emailHeaders .= "Content-type: text/html; charset=utf-8\r\n";
		$mailSentSuccess = mail( $to, $subject, $message, $emailHeaders);
		return $mailSentSuccess;
	}
	
	//email data should 'inherit' from site and application data, could load them here in sendMail, but 
	//better to think of a more generic solution.

/*
		$emailConfigData['from']
		$emailConfigData['replyTo']
		$emailConfigData['toEmailAddresses']	array of email addresses
		$emailConfigData['ccEmailAddresses']	array of email addresses
		$emailConfigData['bccEmailAddresses']	array of email addresses
		$emailConfigData['emailTemplate']
		$emailConfigData['emailData']
 */
	public function sendMail( $emailConfigData) {

		//load email content:
		$emailTemplateData = loadData( $emailConfigData['emailTemplate'], 'email');
		if( !isset( $emailTemplateData) || empty( $emailTemplateData) ) {
			$emailTemplateData = array();
		}

		$emailTemplateData['view'] = array_merge( $emailTemplateData, $emailConfigData['emailData']); 

		global $SITE_LOCATION;
		$emailTemplatePath = $SITE_LOCATION . '/design/emails/' . $emailConfigData['emailTemplate'] . '/';

		global $contentigo;
		$subjectTemplateName = $emailConfigData['emailTemplate'] . '_subject';
		$subject = $contentigo->returnTemplateContent( $emailTemplatePath, $subjectTemplateName, $emailTemplateData);
		
		$subject = "=?UTF-8?B?" .base64_encode($subject) . "?=";
		//$subject = "?UTF-8?Q?". imap_8bit($subject) . "?=";

		$messageTemplateName = $emailConfigData['emailTemplate'] . '_message';
		$message = $contentigo->returnTemplateContent( $emailTemplatePath, $messageTemplateName, $emailTemplateData);


		$to = null; 
		if( isset( $emailConfigData['toEmailAddresses']) && !empty( $emailConfigData['toEmailAddresses'])) {
			$to = implode(', ', $emailConfigData['toEmailAddresses']);
		}

		//$headers = "Content-type: text/html; charset=utf-8\r\n";
		$headers = 'MIME-Version: 1.0' . "\r\n" . 'Content-type: text/plain; charset=UTF-8' . "\r\n";

		if( isset( $emailConfigData['from']) && !empty( $emailConfigData['from']) ) {
			$headers .= 'From: ' . $emailConfigData['from'] . "\r\n";
			if( isset( $emailConfigData['replyTo']) && !empty( $emailConfigData['replyTo']) ) {
				$headers .= 'Reply-To: ' . $emailConfigData['replyTo'] . "\r\n";
			}
		}

		if( isset( $emailConfigData['ccEmailAddresses']) && !empty( $emailConfigData['ccEmailAddresses'])) {
			$ccEmailAddresses = implode(', ', $emailConfigData['ccEmailAddresses']);
			$headers .= 'Cc: ' . $ccEmailAddresses . "\r\n";
		}

		if( isset( $emailConfigData['bccEmailAddresses']) && !empty( $emailConfigData['bccEmailAddresses'])) {
			$bccEmailAddresses = implode(', ', $emailConfigData['bccEmailAddresses']);
			$headers .= 'Bcc: ' . $bccEmailAddresses . "\r\n";
		}

		$sendEmails = true;

		//check if email module in debug mode etc:
		global $site;
		if( array_key_exists( CSM_DEBUG_EMAILS, $site) && true === $site[CSM_DEBUG_EMAILS] ) {
			if( array_key_exists( CSM_DEBUG_EMAIL_DIRECTORY, $site) && !empty( $site[CSM_DEBUG_EMAIL_DIRECTORY])) {
				
				if( !file_exists( $site[CSM_DEBUG_EMAIL_DIRECTORY]) ) {
					//attempt to create the directory:
					mkdir( $site[CSM_DEBUG_EMAIL_DIRECTORY], 0700, true);
				}
				
				$debugEmailFileExtension = '.txt';
				if( array_key_exists( CSM_DEBUG_EMAIL_FILE_EXTENSION, $site) && !empty( $site[CSM_DEBUG_EMAIL_FILE_EXTENSION])) {
					$debugEmailFileExtension = '.' . $site[ CSM_DEBUG_EMAIL_FILE_EXTENSION];
				}
				
				file_put_contents( $site[CSM_DEBUG_EMAIL_DIRECTORY] . $subjectTemplateName . $debugEmailFileExtension, $subject);
				file_put_contents( $site[CSM_DEBUG_EMAIL_DIRECTORY] . $messageTemplateName . $debugEmailFileExtension, $message);
				$headersFilename = $emailConfigData['emailTemplate'] . '_headers';
				file_put_contents( $site[CSM_DEBUG_EMAIL_DIRECTORY] . $headersFilename . $debugEmailFileExtension, $headers);
			}

			if( array_key_exists( CSM_DEBUG_SEND_EMAILS, $site) && false === $site[CSM_DEBUG_SEND_EMAILS] ) {
				$sendEmails = false;
			}

		}


		if( !$sendEmails) {
			return true;
		}
				
/*		
$boundary = "nextPart";    //->>>>>>>>>>>>>>>>>>> Separador entre distintos tipos de content-type

$headers = "FROM: Tyven Systems <no-reply@tyven.com>\r\n";
$headers .= "MIME-Version: 1.0\r\n";
$headers .= "Content-Type: multipart/alternative; boundary = $boundary\r\n\r\n";     ////---->>>   Le digo que vamos a usar varios content-types y que vienen  marcados por el boundary
$headers .= "This is a MIME encoded message.\r\n\r\n";

//text version    /// ->>>>>>>>>>>>>>aqui marcamos la parte de TEXTO
$headers .= "--$boundary\n
Content-Type: text/plain; charset=UTF-8\r\n
Content-Transfer_Encoding: 7bit\r\n\r\n";
$headers .= "foo\r\n\r\n";

// html version    -----> Y aqui viene la parte de html
$headers .= "--$boundary\r\n
Content-Type: text/html; charset=UTF-8\r\n
Content-Transfer_Encoding: 7bit\r\n\r\n";

//$headers .= "<h1>This is</h1> the <b>HTML</b> version";
$headers .= $emailBody;

Logger::log("****************************************************** " . $emailBody);

$mailSentSuccess = mail( $emailAddress, mb_encode_mimeheader($emailSubject, 'UTF-8'), '', $headers);
*/		
		
		// Sends email to new customer providing the account information
		
		//'$emailAddress' maybe a single address, or: foo, bar, baz (multiple)
		$mailSentSuccess = mail( $to, $subject, $message, $headers);		
		//$mailSentSuccess = mail( $emailAddress, mb_encode_mimeheader($emailSubject, 'UTF-8'), $emailBody, $emailHeaders); 
			
		return $mailSentSuccess;
	}
	
}
?>